package com.mediahub

import akka.stream.scaladsl.Source

class MovieQueryService {

  final case class Principal(
                              name: String,
                              birthYear: Int,
                              deathYear: Option[Int],
                              profession: List[String])

  final case class TvSeries(
                             original: String,
                             startYear: Int,
                             endYear: Option[Int],
                             genres: List[String])

  trait MovieService {
    def principalsForMovieName(name: String): Source[Principal, _]

    def tvSeriesWithGreatestNumberOfEpisodes(): Source[TvSeries, _]
  }

}


